<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="text"/>

<xsl:template match="/">
	package <xsl:value-of select="//Package"/>; 
		
	<xsl:apply-templates select="//Import"/>

	public class <xsl:value-of select="JavaBean/@nome"/> extends <xsl:value-of select="//Superclass/@nome"/> {
		
		<xsl:apply-templates select="//Property" mode="var"/>

		public <xsl:value-of select="JavaBean/@nome"/>(){}

		<xsl:apply-templates select="//Property" mode="get"/>
		<xsl:apply-templates select="//Property" mode="set"/>
	}
</xsl:template>
	
<xsl:template match="Import">
	import <xsl:value-of select="."/>;
</xsl:template>

<xsl:template match="Property" mode="var">
		private <xsl:value-of select="@tipo"/><xsl:text> </xsl:text><xsl:value-of select="@nome"/>;
</xsl:template>

<xsl:template match="Property" mode="get">
		public <xsl:value-of select="@tipo"/> get<xsl:call-template name="initLowUp">
					<xsl:with-param name="x" select="@nome"/>
				</xsl:call-template>() {
			return <xsl:value-of select="@nome"/>;
		}
</xsl:template>
	
<xsl:template match="Property" mode="set">
		public void set<xsl:call-template name="initLowUp">
					<xsl:with-param name="x" select="@nome"/>
				</xsl:call-template>(<xsl:value-of select="@tipo"/> param<xsl:call-template name="initLowUp">
					<xsl:with-param name="x" select="@nome"/>
				</xsl:call-template>) {
				
			<xsl:value-of select="@nome"/> = param<xsl:call-template name="initLowUp">
				<xsl:with-param name="x" select="@nome"/>
			</xsl:call-template>;
		}
</xsl:template>

<xsl:template name="initLowUp">
	<xsl:param name="x"/>
	<xsl:value-of select="translate(substring($x,1,1)
							,'abcdefghijklmnopqrstuvwxyz'
							,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
	<xsl:value-of select="substring($x,2)"/>
</xsl:template>

	
</xsl:stylesheet>
